<?php
namespace tests\Zeedhi\Tools\EntityGenerators;

use Doctrine\ORM\EntityManager;
use Symfony\Component\DependencyInjection\ContainerBuilder;
use Zeedhi\Tools\EntityGenerator\ClassGenerator;
use Zeedhi\Tools\Generator\GeneratorConfig;
use Zeedhi\Tools\TableImporter\TableImporter;
use Zeedhi\Tools\EntityGenerator\MetaData;

class ClassGeneratorTest extends \PHPUnit_Framework_TestCase {

    /** @var ClassGenerator */
    protected $classGenerator;
    protected $tableImporter;
    protected $metadataGenerator;
    protected $metaData;
    protected $data;
    protected $entities;
    protected $entitiesNames;

    protected function setUp() {
        $tablesToImportConnection = \Doctrine\DBAL\DriverManager::getConnection(array(
            'driver'    => 'oci8',
            'user'      => 'USR_ORG_20',
            'password'  => 'teknisa',
            'host'      => '192.168.122.5',
            'port'      => '1521',
            'dbname'    => 'pdborcl',
            'service'   => true
        ));
        $databaseReader = DatabaseReader::factoryFromConnection($tablesToImportConnection);
        
        $this->entities = json_decode(file_get_contents(__DIR__."/../../../mocks/entities.json"), true);
      
        $this->tableImporter = new TableImporter($databaseReader);
        $this->tableImporter->importTablesWithSubModel($entities["subModelsByTables"]);
        $this->data = $this->tableImporter->getData();
        
        $this->metadataGenerator = new Metadata(new Inflector());
        $this->entitiesNames = $this->metadataGenerator->generateEntitiesForTableNames($tableNames, $entities["namespace"], $entities["subModelsByTables"]);
        $this->metaData = $this->metadataGenerator->getMetaData();

        $this->classGenerator = new ClassGenerator();
    }

    public function testCreateClassesFiles() {
        $generated = $this->classGenerator->createClassesFiles($this->config, $this->metaData);
        $this->assertTrue($generated);
    }
}
 